<div class="container">
    <div class="row">
      <div class="col-md-6 mx-auto">
        <form [formGroup]="signupForm" (ngSubmit)="onSubmit()">
          <div class="form-group">
            <label for="firstName">First Name</label>
            <input type="text" class="form-control" id="firstName" formControlName="firstName">
            <div *ngIf="signupForm.get('firstName')!.invalid && (signupForm.get('firstName')!.dirty || signupForm.get('firstName')!.touched)">
              <small class="text-danger" *ngIf="signupForm.get('firstName')!.errors!['required']">First Name is required.</small>
            </div>
          </div>
  
          <div class="form-group">
            <label for="lastName">Last Name</label>
            <input type="text" class="form-control" id="lastName" formControlName="lastName">
            <div *ngIf="signupForm.get('lastName')!.invalid && (signupForm.get('lastName')!.dirty || signupForm.get('lastName')!.touched)">
              <small class="text-danger" *ngIf="signupForm.get('lastName')!.errors!['required']">Last Name is required.</small>
            </div>
          </div>
  
          <div class="form-group">
            <label for="email">Email</label>
            <input type="email" class="form-control" id="email" formControlName="email">
            <div *ngIf="signupForm.get('email')!.invalid && (signupForm.get('email')!.dirty || signupForm.get('email')!.touched)">
              <small class="text-danger" *ngIf="signupForm.get('email')!.errors!['required']">Email is required.</small>
              <small class="text-danger" *ngIf="signupForm.get('email')!.errors!['email']">Invalid email format.</small>
            </div>
          </div>
  
          <div class="form-group">
            <label for="address">Address</label>
            <textarea class="form-control" id="address" formControlName="address"></textarea>
            <div *ngIf="signupForm.get('address')!.invalid && (signupForm.get('address')!.dirty || signupForm.get('address')!.touched)">
              <small class="text-danger" *ngIf="signupForm.get('address')!.errors!['required']">Address is required.</small>
            </div>
          </div>
  
          <button type="submit" class="btn btn-primary">Submit </button>
          <button type="reset" class="btn btn-secondary">Cancel </button>
        </form>
      </div>
    </div>
</div>